VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8535
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   17055
   LinkTopic       =   "Form1"
   ScaleHeight     =   8535
   ScaleWidth      =   17055
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command2 
      Caption         =   "Subdivide -"
      Height          =   375
      Left            =   9840
      TabIndex        =   7
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Subdivide +"
      Height          =   375
      Left            =   8520
      TabIndex        =   3
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton BtnZoomOut 
      Caption         =   "Zoom Out"
      Height          =   375
      Left            =   7200
      TabIndex        =   6
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton BtnZoomIn 
      Caption         =   "Zoom In"
      Height          =   375
      Left            =   5880
      TabIndex        =   5
      Top             =   120
      Width           =   1335
   End
   Begin VB.PictureBox Picture2 
      BackColor       =   &H00FFFFFF&
      Height          =   7935
      Left            =   8520
      ScaleHeight     =   7875
      ScaleWidth      =   8355
      TabIndex        =   4
      Top             =   480
      Width           =   8415
   End
   Begin VB.OptionButton Option2 
      Caption         =   "xz"
      Height          =   255
      Left            =   960
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.OptionButton Option1 
      Caption         =   "xy"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Value           =   -1  'True
      Width           =   615
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   7935
      Left            =   120
      ScaleHeight     =   7875
      ScaleWidth      =   8355
      TabIndex        =   0
      Top             =   480
      Width           =   8415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim icosphere As Object3D
Dim newics()  As Object3D
Dim colors()  As Long
Dim c As Long

Private Sub BtnZoomIn_Click()
    Module1.sc = Module1.sc * 1.5
    Draw1
    Draw2
End Sub
Private Sub BtnZoomOut_Click()
    Module1.sc = Module1.sc / 1.5
    Draw1
    Draw2
End Sub

Private Sub Form_Load()
    
    icosphere = CreateIcosahedron(IcosahedronPoint_r(1))
    Dim i As Long
    ReDim newics(0 To 6)
    ReDim colors(0 To 6)
    newics(i) = icosphere 'kopieren
    Debug.Print "i: " & i & " | " & CheckEulerPolyeder(newics(i))
    For i = 1 To 6
        newics(i) = Icosahedron_subdivide(newics(i - 1))
        Debug.Print "i: " & i & " | p: " & CheckEulerPolyeder(newics(i))
        colors(i) = RGB(Rnd * 256, Rnd * 256, Rnd * 256)
    Next
    
    BtnZoomIn.Caption = "Zoom In"
    BtnZoomOut.Caption = "Zoom Out"
    Command1.Caption = "Subdivide +"
    Command2.Caption = "Subdivide -"
    Option1.Caption = "xy"
    Option2.Caption = "xz"
    Picture1.ScaleMode = vbPixels
    Picture1.AutoRedraw = True
    Picture2.ScaleMode = vbPixels
    Picture2.AutoRedraw = True
    Draw1
    Draw2
    
End Sub

Private Sub Command1_Click()
    c = c + 1
    If c = 7 Then c = 0
    Draw1
    Draw2
End Sub
Private Sub Command2_Click()
    c = c - 1
    If c < 0 Then c = 0
    Draw1
    Draw2
End Sub

Private Sub Form_Resize()
    Dim L: L = 8 * Screen.TwipsPerPixelX
    Dim T: T = Picture1.Top
    Dim W: W = (Me.ScaleWidth - 2 * L) / 2
    Dim H: H = Me.ScaleHeight - T - L
    If W > 0 And H > 0 Then
        Picture1.Move L, T, W, H
        Draw1
        L = L + W
        If W > 0 And H > 0 Then
            Picture2.Move L, T, W, H
            Command1.Left = L
            Command2.Left = L + Command1.Width
            BtnZoomOut.Left = L - BtnZoomOut.Width
            BtnZoomIn.Left = L - BtnZoomOut.Width - BtnZoomIn.Width
            Draw2
        End If
    End If
End Sub

Private Sub Option1_Click()
    Draw1
    Draw2
End Sub
Private Sub Option2_Click()
    Draw1
    Draw2
End Sub

Private Sub Draw1()
    Picture1.Cls
    If Option1.Value Then
        Module1.DrawObj3D_xy Picture1, icosphere, vbBlack
    ElseIf Option2.Value Then
        Module1.DrawObj3D_xz Picture1, icosphere, vbBlack
    End If
End Sub

Private Sub Draw2()
    Picture2.Cls
    Dim i As Long
    For i = 0 To c
        If Option1.Value Then
            Module1.DrawObj3D_xy Picture2, newics(i), colors(i)
        ElseIf Option2.Value Then
            Module1.DrawObj3D_xz Picture2, newics(i), colors(i)
        End If
    Next
End Sub
