VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8535
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   18045
   LinkTopic       =   "Form1"
   ScaleHeight     =   8535
   ScaleWidth      =   18045
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox Check3 
      Caption         =   "Perspective"
      Height          =   255
      Left            =   1560
      TabIndex        =   14
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton Command6 
      Caption         =   "RotSpeed -"
      Height          =   375
      Left            =   14760
      TabIndex        =   13
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command5 
      Caption         =   "RotSpeed +"
      Height          =   375
      Left            =   13560
      TabIndex        =   12
      Top             =   120
      Width           =   1215
   End
   Begin VB.CheckBox Check2 
      Caption         =   "Rotate"
      Height          =   255
      Left            =   12480
      TabIndex        =   11
      Top             =   120
      Width           =   975
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   0
      Top             =   480
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Eggify"
      Height          =   375
      Left            =   11160
      TabIndex        =   10
      Top             =   120
      Width           =   1215
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Show all inner shapes"
      Height          =   255
      Left            =   7920
      TabIndex        =   8
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Subdivide -"
      Height          =   375
      Left            =   6600
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Subdivide +"
      Height          =   375
      Left            =   5400
      TabIndex        =   3
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton BtnZoomOut 
      Caption         =   "Zoom Out"
      Height          =   375
      Left            =   4200
      TabIndex        =   6
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton BtnZoomIn 
      Caption         =   "Zoom In"
      Height          =   375
      Left            =   3000
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Euler?"
      Height          =   375
      Left            =   9960
      TabIndex        =   9
      Top             =   120
      Width           =   1215
   End
   Begin VB.PictureBox Picture2 
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   7935
      Left            =   8520
      ScaleHeight     =   7875
      ScaleWidth      =   8355
      TabIndex        =   4
      Top             =   480
      Width           =   8415
   End
   Begin VB.OptionButton Option2 
      Caption         =   "xz"
      Height          =   255
      Left            =   840
      TabIndex        =   2
      Top             =   120
      Width           =   615
   End
   Begin VB.OptionButton Option1 
      Caption         =   "xy"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Value           =   -1  'True
      Width           =   615
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   7935
      Left            =   120
      ScaleHeight     =   7875
      ScaleWidth      =   8355
      TabIndex        =   0
      Top             =   480
      Width           =   8415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim icosphere As Object3D
Dim newics()  As Object3D
Dim colors()  As Long
Dim c As Long
Dim egg_x_fact_pos As Double
Dim egg_x_fact_neg As Double
Dim egg_z_fact_pos As Double
Dim egg_z_fact_neg As Double
Dim rotangle As Double
Dim rotspeed As Double
Dim m_Projection As Matrix34

Private Sub Check2_Click()
    Timer1.Enabled = Check2.Value = vbChecked
    Draw2
End Sub

Private Sub Form_Load()
    
    icosphere = CreateIcosahedron(IcosahedronPoint_r(1))
    Dim i As Long
    ReDim newics(0 To 6)
    ReDim colors(0 To 6)
    newics(i) = icosphere 'kopieren
    'Debug.Print "i: " & i & " | " & CheckEulerPolyeder(newics(i))
    For i = 1 To 6
        newics(i) = Icosahedron_subdivide(newics(i - 1))
        'Debug.Print "i: " & i & " | p: " & CheckEulerPolyeder(newics(i))
        colors(i) = RGB(Rnd * 256, Rnd * 256, Rnd * 256)
    Next
    M2D.Pi = 4 * Atn(1)
    M2D.Pi2 = 4 * Atn(1) * 2
    
    rotspeed = 1
    Timer1.Interval = 20
    Timer1.Enabled = False
    Option1.Caption = "xy"
    Option2.Caption = "xz"
    Check3.Caption = "Perspective"
    'Option3.Caption = "Projection"
    BtnZoomIn.Caption = "Zoom In"
    BtnZoomOut.Caption = "Zoom Out"
    Command1.Caption = "Subdivide +"
    Command2.Caption = "Subdivide -"
    Command3.Caption = "Euler?"
    Picture1.ScaleMode = vbPixels
    Picture1.AutoRedraw = True
    Picture2.ScaleMode = vbPixels
    Picture2.AutoRedraw = True
    Dim tx As Double: tx = Picture2.ScaleWidth / 2
    Dim tz As Double: tz = Picture2.ScaleHeight / 2
    m_Projection = New_Matrix34Camera(3000, 1, 1, tx, tz, 0, 0, 15, 0, 0, 0)
    Draw1
    Draw2
    
End Sub

Private Sub BtnZoomIn_Click()
    M3D.ZoomIn
    InitProjection
    Draw1
    Draw2
End Sub
Private Sub BtnZoomOut_Click()
    M3D.ZoomOut
    InitProjection
    Draw1
    Draw2
End Sub
Private Sub Command1_Click()
    c = IIf(c = 6, 0, c + 1)
    Picture1.ForeColor = colors(c)
    Draw2
End Sub
Private Sub Command2_Click()
    c = IIf(c = 0, 6, c - 1)
    Picture1.ForeColor = colors(c)
    Draw2
End Sub
Private Sub Check1_Click()
    Draw1
    Draw2
End Sub
Private Sub Command3_Click()
    MsgBox M3D.CheckEulerPolyeder(newics(c))
End Sub
Private Sub Command4_Click()
    Dim s As String: s = InputBox("Gib ein: x/z; fact_pos; fact_neg", "Eggify a polyeder", "x; 1.618; 1.221")
    If Len(s) = 0 Then Exit Sub
    Dim sa() As String: sa = Split(s, ";")
    Dim xz       As String:       xz = Trim(sa(0))
    Dim fact_pos As Double: fact_pos = Val(Trim(sa(1)))
    Dim fact_neg As Double: fact_neg = Val(Trim(sa(2)))
    If xz = "x" Then
        newics(c) = Eggify_x(newics(c), 0, fact_pos, fact_neg)
    ElseIf xz = "z" Then
        newics(c) = Eggify_z(newics(c), 0, fact_pos, fact_neg)
    End If
    Draw2
End Sub
Private Sub Command5_Click()
    rotspeed = IIf(rotspeed = 360, 1, rotspeed + 1)
End Sub
Private Sub Command6_Click()
    rotspeed = IIf(rotspeed = 0, 1, rotspeed - 1)
End Sub

Private Sub Form_Resize()
    Dim brdr: brdr = 8 * Screen.TwipsPerPixelX
    Dim l: l = brdr
    Dim t: t = Picture1.Top
    Dim W: W = (Me.ScaleWidth - 2 * l) / 2
    Dim H: H = Me.ScaleHeight - t - l
    If W > 0 And H > 0 Then
        Picture1.Move l, t, W, H
        InitProjection
        Draw1
        l = l + W
        If W > 0 And H > 0 Then
            Picture2.Move l, t, W, H
'            Command1.Left = l
'            Command2.Left = l + Command1.Width
'            Check1.Left = l + Command1.Width + Command2.Width + brdr
'            Command3.Left = Check1.Left + Check1.Width + brdr
'            Command4.Left = Command3.Left + Command3.Width
'            BtnZoomOut.Left = l - BtnZoomOut.Width
'            BtnZoomIn.Left = l - BtnZoomOut.Width - BtnZoomIn.Width
            Draw2
        End If
    End If
End Sub
Private Sub InitProjection()
    Dim tx As Double: tx = Picture1.ScaleWidth / 2
    Dim tz As Double: tz = Picture1.ScaleHeight / 2
    Dim ax As Double
    If Option1.Value Then
        ax = 0
    ElseIf Option2.Value Then
        ax = Pi / 2
    End If
    m_Projection = New_Matrix34Camera(300, 60 / M3D.sc, 60 / M3D.sc, tx, tz, 0, 0, 5, ax, 0, 0)
End Sub
Private Sub Option1_Click()
    If Check3.Value = vbChecked Then InitProjection
    Draw1
    Draw2
End Sub
Private Sub Option2_Click()
    If Check3.Value = vbChecked Then InitProjection
    Draw1
    Draw2
End Sub
Private Sub Check3_Click()
    Draw1
    Draw2
End Sub

Private Sub Draw1()
    Picture1.Cls
    If Check3.Value = vbChecked Then
        M3D.DrawObj3D_projected Picture1, m_Projection, icosphere, vbBlack
    Else
        If Option1.Value Then
            M3D.DrawObj3D_xy Picture1, icosphere, vbBlack
        ElseIf Option2.Value Then
            M3D.DrawObj3D_xz Picture1, icosphere, vbBlack
        End If
    End If
End Sub

Private Sub Draw2()
    Picture2.Cls
    Dim i As Long
    Dim start As Long: start = IIf(Check1.Value = vbChecked, 0, c)
    Dim rotobj As Object3D:
    For i = start To c
        rotobj = newics(i)
        rotobj.points = M3D.Rotate_xy(rotobj.points, 0, 0, rotangle * Pi / 180)
        If Check3.Value = vbChecked Then
            M3D.DrawObj3D_projected Picture2, m_Projection, rotobj, colors(i)
        Else
            If Option1.Value Then
                M3D.DrawObj3D_xy Picture2, rotobj, colors(i)
            ElseIf Option2.Value Then
                M3D.DrawObj3D_xz Picture2, rotobj, colors(i)
            End If
        End If
    Next
End Sub

Private Sub Timer1_Timer()
    If Check2.Value = vbChecked Then
        rotangle = rotangle + rotspeed
        Draw2
    End If
End Sub
